#!/usr/bin/perl

use POSIX qw/:sys_wait_h /;

use strict;

sub _log {
  warn($_[0]);
}

sub REAPER {
    local ($!, $?);
  while ((my $waitedpid = waitpid(-1, WNOHANG)) > 0) { 
	_log("Reaper: child $waitedpid exited");
  }
   $SIG{CHLD} = \&REAPER;
}

sub main_stdin {

  while (1) {
    my $l = <STDIN>;
    if (!defined($l)) {
	_log("error: ".$!);
    }
    last if (!defined($l));
    if (!fork()) { exit(0); }
  }
    _log("Exiting main_stdin()");
}

# main

$SIG{CHLD} = \&REAPER;
#$SIG{CHLD} = 'IGNORE';

main_stdin();
exit 0;

